package ass.sivakfil;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.List;

/** 
 * @author AwesomeProgrammerDude
 * DONT TOUCH MY CODE!
 */
public class MessageRepository extends LinkedList<String> {
	
	protected File file;
	
	// instance to update when new message is passed
	protected List<ChatView> viewsToNotify = new LinkedList<>();
	
	public MessageRepository(File file) throws IOException {
		super();
		this.file = file;
		
		if(file.exists()) {
			if(!file.canRead()) {
				System.err.println("Sorryjako, tvj soubor nen iteln!");
				System.exit(0);
			}
			
			BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
			String line = "";
			while((line = br.readLine()) != null) {
				add(line);
			}
		}
	}

	public void addViewForNotifications(ChatView view) {
		viewsToNotify.add(view);
	}
	
	public boolean add(String s) {
		for(ChatView view : viewsToNotify) {
			view.notifyChange(s);
		}
		return super.add(s);
	}
	
	public void save() throws IOException {
		PrintWriter pw = new PrintWriter(file);
		for(String line : this) {
			pw.println(line);
		}
		pw.close();
	}
	
	public void clear() {
		file.delete();
	}
	
}
